#define detect 3        //детектор нуля
#define triac 5        //тиристор

double ACS_coeff = 0.024414063; // Коэффициент датчика ACS712 |5А - 0.024414063 | 20А - 0.048828125 | 30A - 0.073242188 |

String Var;
String T1, T2;

volatile unsigned long Iism = 0; //мгновенные значения тока
volatile int cntr = 0; // счетчик в обработчике прерывания
volatile unsigned long Isumm = 0; // переменная для хранения суммы квадратов

double real_I = 0; //переменная расчета RMS тока
float sqrtUsum = 0.0; //переменная расчете квадратного корня
double ust_I = 0;//установленный ток
unsigned long previousMillis = 0;
unsigned long previousMillis_info = 0;
unsigned long reg_time = 0;

int angle_I = 2250;
int angle_I_ocr = 2250;
int zero = 0;

int koef = 0;

#include <Wire.h>                                     // подключаем библиотеку для работы с шиной I2C
#include <iarduino_I2C_connect.h>                     // подключаем библиотеку для соединения arduino по шине I2C
// Объявляем переменные и константы:
iarduino_I2C_connect I2C2;                            // объявляем переменную для работы c библиотекой iarduino_I2C_connect

byte           REG_Massive[7];
int MMM; // объявляем массив, данные которого будут доступны для чтения/записи по шине I2C
int NNN;
int symma = 0;
int tok = 0;
int symma_tok1 = 0;
int symma_tok2 = 0;

void setup(void) {
  Wire.begin(0x02);                                   // инициируем подключение к шине I2C в качестве ведомого (slave) устройства, с указанием своего адреса на шине.
  I2C2.begin(REG_Massive);                            // инициируем возможность чтения/записи данных по шине I2C, из/в указываемый массив

  Serial.begin(9600);//активируем прием сообщения

  pinMode(detect, INPUT);     //детектор нуля
  pinMode(triac, OUTPUT);      //тиристор

  //===========================================================Настройка АЦП

  ADMUX = (0 << REFS1) | (1 << REFS0) | (0 << MUX2) | (0 << MUX1) | (1 << MUX0); //

  /*     Биты 7:6 – REFS1:REFS0. Биты выбора опорного напряжения. Если мы будем менять эти биты во время преобразования,
        то изменения вступят в силу только после текущего преобразования. В качестве опорного напряжения может быть выбран AVcc
        (ток источника питания), AREF или внутренний 2.56В источник опорного напряжения.
        Рассмотрим какие же значения можно записать в эти биты:
        REFS1:REFS0
        00    AREF
        01    AVcc, с внешним конденсатором на AREF
        10    Резерв
        11    Внутренний 2.56В  источник, с внешним конденсатором на AREF
        Бит 5 – ADLAR. Определяет как результат преобразования запишется в регистры ADCL и ADCH.
        ADLAR = 0
        Биты 3:0 – MUX3:MUX0 – Биты выбора аналогового канала.
        MUX3:0
        0000      ADC0
        0001      ADC1
        0010      ADC2
        0011      ADC3
        0100      ADC4
        0101      ADC5
        0110      ADC6
        0111      ADC7*/

  //--------------------------Включение АЦП

  ADCSRA = B11101111;
  /*    Бит 7 – ADEN. Разрешение АЦП.
       0 – АЦП выключен
       1 – АЦП включен
       Бит 6 – ADSC. Запуск преобразования (в режиме однократного
       преобразования)
       0 – преобразование завершено
       1 – начать преобразование
       Бит 5 – ADFR. Выбор режима работы АЦП
       0 – режим однократного преобразования
       1 – режим непрерывного преобразования
       Бит 4 – ADIF. Флаг прерывания от АЦП. Бит устанавливается, когда преобразование закончено.
       Бит 3 – ADIE. Разрешение прерывания от АЦП
       0 – прерывание запрещено
       1 – прерывание разрешено
       Прерывание от АЦП генерируется (если разрешено) по завершении преобразования.
       Биты 2:1 – ADPS2:ADPS0. Тактовая частота АЦП
       ADPS2:ADPS0
       000         СК/2
       001         СК/2
       010         СК/4
       011         СК/8
       100         СК/16
       101         СК/32
       110         СК/64
       111         СК/128*/

  //------ Timer1 ---------- Таймер задержки времени открытия триака после детектирования нуля (0 триак не откроется)

  TCCR1A = 0x00;  //
  TCCR1B = 0x00;    //
  TCCR1B = (0 << CS12) | (1 << CS11) | (1 << CS10); // Тактирование от CLK.

  // Если нужен предделитель :
  // TCCR1B |= (1<<CS10);           // CLK/1 = 0,0000000625 * 1 = 0,0000000625, 0,01с / 0,0000000625 = 160000 отсчетов 1 полупериод
  // TCCR1B |= (1<<CS11);           // CLK/8 = 0,0000000625 * 8 = 0,0000005, 0,01с / 0,0000005 = 20000 отсчетов 1 полупериод
  // TCCR1B |= (1<<CS10)|(1<<CS11); // CLK/64 = 0,0000000625 * 64 = 0,000004, 0,01с / 0,000004 = 2500 отсчетов 1 полупериод
  // TCCR1B |= (1<<CS12);           // CLK/256  = 0,0000000625 * 256 = 0,000016, 0,01с / 0,000016 = 625 отсчетов 1 полупериод
  // TCCR1B |= (1<<CS10)|(1<<CS12); // CLK/1024
  // Верхняя граница счета. Диапазон от 0 до 255.
  OCR1A = 0;           // Верхняя граница счета. Диапазон от 0 до 65535.

  // Частота прерываний будет = Fclk/(N*(1+OCR1A))
  // где N - коэф. предделителя (1, 8, 64, 256 или 1024)

  TIMSK1 |= (1 << OCIE1A) | (1 << TOIE1); // Разрешить прерывание по совпадению и переполнению

  attachInterrupt(1, zero_crosss_int, RISING);//вызов прерывания при детектировании нуля

}
//======================================================== Прерывание по нулю
void zero_crosss_int() {

  TCNT1 = 0;
  OCR1A = angle_I_ocr;
  zero++;
}

//======================================================== Обработка таймера по совпадению нуля

ISR (TIMER1_COMPA_vect)
{
  PORTD |=  (1 << PORTD5);
  TCNT1 = 65535 - 200;  //Импульс включения симистора 65536 -  1 - 4 мкс, 2 - 8 мкс, 3 - 12 мкс и тд
}

ISR (TIMER1_OVF_vect) { //timer1 overflow
  if (MMM < 3510) PORTD &=  ~(1 << PORTD5);///////////////////////////////////////////////////////////////////////////////////////////////////
  TCNT1 = OCR1A + 1;
}

//======================================================== Обработка прерывания АЦП для расчета среднеквадратичного тока
ISR(ADC_vect)
{
  byte An_pin = ADCL;
  byte An = ADCH;
  Iism = ((An << 8) + An_pin) - 512;
  Iism *= Iism;// возводим значение в квадрат
  Isumm += Iism; // складываем квадраты измерений
  cntr++;
}

void loop(void) {

  if (MMM >= 3510) PORTD |=  (1 << PORTD5);////////////////////////////////////////////////////////////////////////////////////////////

  if (zero >= 6) {//расчет среднеквадратичного//zero - количество полупериодов дря рассчета среднеквадратичного
    sqrtUsum = Isumm / cntr; //
    real_I = sqrt(sqrtUsum) * ACS_coeff; //
    cntr = 0;
    Isumm = 0;// обнуляем суммы напряжений
    zero = 0;
  }

  if (ust_I < 0) { //Если меньше 0, то 0
    ust_I = 0;
  }

  if (ust_I == 0) {
    TIMSK1 = 0x00;
    PORTD &=  ~(1 << PORTD5);
  }

  else
  {
    TIMSK1 |= (1 << OCIE1A) | (1 << TOIE1);
  }
  //==============================================Регулятор тока

  if (millis() - previousMillis >= 15) { //Если регулировка долгая то уменьшите значение, если видно частые изменения регулировки то увеличте значение
    previousMillis = millis();
    if (real_I <= ust_I - 1.00  || real_I  >= ust_I + 1.00) koef = 10;
    else koef = 1;

    if (real_I > ust_I + 0.05) {
      angle_I = angle_I + koef;
    }
    if (real_I < ust_I - 0.05) {
      angle_I = angle_I - koef;
    }
    if (real_I <= ust_I + 0.05 && real_I >= ust_I - 0.05) {
      angle_I = angle_I;
    }

    if (angle_I > 2250) {
      angle_I = 2250;
    }
    if (angle_I <= 1) {
      angle_I = 1;
    }
    //передаем значения тока

  }

  //------------------------------------

  angle_I_ocr = angle_I;

  //=========================Информация в порт раз в секунду

 // ust_I = MMM / 220.00;//=============================================================

  if (millis() - previousMillis_info >= 1000) {
previousMillis_info = millis();
    //  ust_I = ust_I + 0.10;//===========================================================
ust_I = 20;
    Serial.print("realI "); //Измеренный среднеквадратичный ток
    Serial.println(real_I);

    Serial.print("MMM "); //Установленный угол
    Serial.println(MMM);

    Serial.print("ustI  "); //Установленный выходной ток
    Serial.println(ust_I);

    Serial.print("мощн  "); //Установленный угол
    Serial.println(NNN);

    Serial.print("koef "); //Установленный угол
    Serial.println(koef);
    Serial.print("angle_I "); //Установленный угол
    Serial.println(angle_I);
    Serial.println("-----------------");
  }
  //========================================================
  NNN = round (real_I * 220);
  REG_Massive[3] = NNN >> 8;         // Сохраняем старший байт значения потенциометра в  1 ячейку массива REG_Massive
  REG_Massive[4] = NNN;              // Сохраняем младший байт значения потенциометра во 2 ячейку массива REG_Massive
  symma = round( NNN / 16);          // проверочное значение
  REG_Massive[5] = symma;

  tok = REG_Massive[1] << 8;
  tok += REG_Massive[2];
  symma_tok1 = round( tok / 16 );
  symma_tok2 = REG_Massive[6];
  if (symma_tok1 == symma_tok2) MMM = tok;
 // MMM = tok;

}







